package api

import (
	"context"
	"testing"

	witnessv1 "github.com/odysseus/odysseus-protocol/gen/proto/go/witness/v1"
	log "github.com/sirupsen/logrus"
	"google.golang.org/grpc"
	"google.golang.org/grpc/credentials/insecure"
)

func TestClient(t *testing.T) {
	client, err := grpc.Dial("127.0.0.1:9431", grpc.WithTransportCredentials(insecure.NewCredentials()),
		grpc.WithDefaultCallOptions(
			grpc.MaxCallRecvMsgSize(1024*1024*1024),
			grpc.MaxCallSendMsgSize(1024*1024*1024)),
	)
	if err != nil {
		panic(err)
	}

	gc := witnessv1.NewWitnessServiceClient(client)

	req := &witnessv1.PushProofRequest{
		Proofs: []*witnessv1.Proof{
			{
				Workload:           10,
				TaskId:             "1",
				ReqHash:            []byte("req"),
				RespHash:           []byte("resp"),
				ManagerSignature:   nil,
				ContainerSignature: nil,
				MinerSignature:     nil,
			},
		},
		RewardAddress: "",
		MinerAddress:  "",
	}

	resp, err := gc.PushProof(context.Background(), req)
	if err != nil {
		log.Fatal(err)
	}

	log.Info(resp.Workload)
}
